import java.util.*;
import java.io.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.

/**
*  This demo is prepared to demostrate how you can use OWRTI package.
*  This is a Chat program based on interactions.
*  
*
* @date May 11, 1998 ( Updated May 11, 1998 )
* @author H. Timucin Ozdemir
*
<changelog>
 <date>6.30.1999</date>
 <desc>gif images are added to the user interface.</desc>
 <date>7.1.1999</date>
 <desc>Buttons are enabled based on the current state. 
       states: A: Not Connected and no federation name.
               B: Not Connected with federation name
               C: Connected
       state transitions:
          A->Name->B
          B->Connect->C
          C->Disconnect->B
 </desc>
</changelog>
*/
public class ChatGUI extends JFrame implements ActionListener {

   String  fedName = "Chatter1";
   String  fedCnfName = fedName+".fed";

   short   federateId;
   ORB     orb;

   String chatterTypeStr = new String("Chatter");
   String chatterMsgTypeStr = new String("Message");

   String SetNameTxt = new String("Name");
   String ExitTxt = new String("Exit");

   short  chatterTypeId = -1;
   int    chatterMsgTypeId = -1;

   java.lang.Object guard = new java.lang.Object();

   /** RTI Mappers */

   Hashtable className       = new Hashtable();
   Hashtable attributeName   = new Hashtable();
   Hashtable interactionName = new Hashtable();
   Hashtable parameterName   = new Hashtable();

   RTIcap.RTIambassador rtiAmb;

   boolean       advanceGranted = false;
   double        currentTime = 0.0; 
   double        timeStep = 5.0; 
   double        requestTime ; 

   /** Log File */
   PrintWriter myLog;

   JButton  connect;
   JButton  mail;
   JButton  disconnect;
   JButton  exit;
   JTextArea rcvMessages; 
   JTextField sendMessage; 

   short     myChatterId;

   boolean   isConnected = false;

   String    myChatterName = null;

   JMenuItem setNameItem;

   JMenuItem exitItem;

   /** */
   public ChatGUI( RTIcap.RTIambassador _rtiAmb, ORB _orb ) {

       rtiAmb = _rtiAmb;
       orb = _orb;

       try 
       { myLog = new PrintWriter(new FileWriter("chat.log"),true);
       } catch( java.io.IOException ioe) {}
  
       JMenuBar menuBar = new JMenuBar();
       JMenu menu ;

       setJMenuBar(menuBar);
       
       //Build the first menu.
       menu = new JMenu("Menu");
       menuBar.add(menu);

       setNameItem = new JMenuItem(SetNameTxt);
       exitItem = new JMenuItem(ExitTxt);

       menu.add(setNameItem);
       menu.add(exitItem);
       setNameItem.addActionListener(this);
       exitItem.addActionListener(this);

       connect=defineJButton("Connect","gif/door02.gif","Connects to OWRTI",KeyEvent.VK_C,false);
       disconnect=defineJButton("Disconnect","gif/door01.gif","Disconnects from OWRTI",KeyEvent.VK_D,false);
       exit=defineJButton("Exit","gif/exit.gif","Stops the program",KeyEvent.VK_E,true);
       mail=defineJButton("Mail","gif/mail.gif","Sends the message",KeyEvent.VK_M,false);

       rcvMessages =  new JTextArea(5, 30);
       rcvMessages.setEditable(false);

       JPanel contentPane = new JPanel();
       contentPane.setLayout(new BorderLayout());
       JPanel nPanel = new JPanel();
       nPanel.add(connect); 
       nPanel.add(mail); 
       nPanel.add(disconnect); 
       nPanel.add(exit); 

       connect.addActionListener(this);
       mail.addActionListener(this);
       disconnect.addActionListener(this);
       exit.addActionListener(this);

       JPanel sPanel = new JPanel();
       sendMessage = new JTextField(30);
       sPanel.add(new JLabel("Message"));
       sPanel.add(sendMessage);
       sendMessage.addActionListener(this);

       contentPane.add(nPanel,BorderLayout.NORTH);       
       contentPane.add(rcvMessages,BorderLayout.CENTER);       
       contentPane.add(sPanel,BorderLayout.SOUTH);       

       setContentPane(contentPane);

   }// end of CONSTRUCTOR

   /** */ 
   public URL getCodeBase() { 
     URL url = null;
     try
     {  url = new URL("file:"+System.getProperty("user.dir")+System.getProperty("file.separator"));
     } catch( MalformedURLException mue) {}
     return url;
   }// end of getCodeBase()

   /**
   *
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   *
   * Ask RTI about the class indentifier of each object, attribute, 
   * interaction and parameter. So that we can define, subscribe, publish,
   * and interpret these attributes/objects.
   *
   */
   boolean getRtiIds()
   {
      boolean ret = false;

      if( rtiAmb != null )
      {
        
         try
         { 
           chatterTypeId = rtiAmb.getInteractionClassHandle(chatterTypeStr);
         } catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         try
         { 
           chatterMsgTypeId = 
                  rtiAmb.getParameterHandle(chatterMsgTypeStr,chatterTypeId);
           ret = true;
         } catch( RTIcap.InteractionClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

      }// end of if
  
      return ret;

   }// end of getRtiIds()

   /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interations and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   */
   boolean publishSubscribe()
   {

      boolean ret = false;

      if( rtiAmb != null )
      {
         try
         {
           rtiAmb.subscribeInteractionClass( chatterTypeId, RTIcap._Boolean.RTI_TRUE);
         } catch( RTIcap.FederateLoggingServiceCalls  flsc) {}
           catch( RTIcap.FederateNotExecutionMember  fnem) {}
           catch( RTIcap.RTIinternalError  ie) {}
           catch( RTIcap.RestoreInProgress  rip) {}
           catch( RTIcap.InteractionClassNotDefined  icnd) {}
           catch( RTIcap.SaveInProgress  sip) {}

         try
         {
           rtiAmb.publishInteractionClass( chatterTypeId );
           ret = true;
         } catch( RTIcap.FederateNotExecutionMember fnem) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.InteractionClassNotDefined icnd) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of publishSubscribe()

   /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   */
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb)
   {

      boolean ret = false;

      if( rtiAmb != null )
      {

         try {
           rtiAmb.createFederationExecution(fedName,fedCnfName);
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {}
           catch( RTIcap.RTIinternalError ie) {}

         try
         {
           Date aDate = new Date();
           
           String aName = myChatterName+aDate;
             federateId = rtiAmb.joinFederationExecution(aName.replace(' ','_'),fedName,fedAmb);
             ret = true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) {}
           catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.CouldNotOpenFED fnem) {}
           catch( RTIcap.ErrorReadingFED fnem) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of joinFederationExecution() 

   /**
   *
   * Before we leave the Federation
   *  1. Delete all the object that we are suppose(promised) to simulate.
   *  2. resign from the federation.
   *  3. Try to destroy the federation execution. Note that if there 
   *     are still federates in the Federation, the federation execution
   *     won't be stopped. Only, we resign it. 
   *
   */
   void leaveFederationExecution()
   {

      if( rtiAmb != null )
      {

         try 
         {
           rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie) {}
           catch( RTIcap.FederateOwnsAttributes ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.RTIinternalError ie) {}

         try 
         {
           rtiAmb.destroyFederationExecution(fedName);
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.FederatesCurrentlyJoined ie) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

   }// end of leaveFederationExecution() 

   /** */
   public void resetTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = false; } 
   }// end of resetTimeAdvanceGranted()

   /**
   * This method will be invoked by HwFededarateAmbassador object whenever
   *
   *   timeAdvanceGrant 
   *   timeConstrainedEnabled
   *   timeRegulationEnabled
   *
   * messages received.
   *
   */
   public void setTimeAdvanceGranted() { 
      synchronized(guard) { advanceGranted = true; } 
   }// end of setTimeAdvanceGranted()

   /** */
   public boolean isTimeAdvanceGranted() { return advanceGranted ; }

   /** */
   public void setCurrentTime( double _newTime) { 
     if( _newTime >= currentTime ) currentTime = _newTime;
   }// end of setCurrentTime()

   /** */
   public final void mySleep(long aa) {  }// end of mySleep()

   /**
   *
   * Ticks the RTIambassador. This will cause the delivery of waiting 
   * events in the Receive Order Queue.
   *
   */
   public void tickRTI( long sleepTime ) {
      while( !isTimeAdvanceGranted() ) {
         try { rtiAmb.tick( ); } 
         catch( RTIcap.RTIinternalError aa ) {}
         mySleep(2);
      }// end of while() 
   }// end of tickRTI()

   /**
   * ActionListener interface to collect the user events.
   * @param e ActionEvent
   */
   public void actionPerformed(ActionEvent e) {
     if( e.getSource() instanceof JMenuItem ) {
        JMenuItem source = (JMenuItem)(e.getSource());
        System.out.println(" action :"+source.getText());
        if( source == exitItem ) doExit();
        else if( source == setNameItem ) doGetName();
     }
     else if( e.getSource() instanceof JButton ) {
            JButton source = (JButton)(e.getSource());
            System.out.println(" action :"+source.getText());

            if( source ==  exit ) doExit();
            else if( source ==  connect ) doConnect();
            else if( source ==  disconnect ) doDisconnect();
            else if( source ==  mail ) doMail();

          }
     else if( e.getSource() instanceof JTextField )
          {
            JTextField source = (JTextField)(e.getSource());
            System.out.println(" action :"+source.getText());
          }

     //if( source.getText().equals(ExitTxt)) doExit();
     //else if( source.getText().equals(OpenURL) ) openURLProcess();

   }// end of actionPerformed()

   /**
   * Move the frame back, and destroy the execution.
   */
   void doExit()
   {
     toBack(); 
     if( isConnected ) { leaveFederationExecution(); isConnected=false; }
     System.exit(0);

   }// end of doExit()

   /**
   * Connects to the Federation Execution
   */
   void doRealyConnect()
   {
      int count = 0;

      myLog.println(" before ChatFedAmb definition ");

      /*******************************************************************/
      /** Define FederateAmbassador for HelloWorld. This objects serves  */
      /** as a callback mechanism so that RTI can bring us the necessary */ 
      /** events.                                                        */
      /*******************************************************************/
      ChatFedAmb fedAmb = new ChatFedAmb(this);
      //orb.connect(fedAmb);
      org.omg.CORBA.ORB.init().connect(fedAmb);

      myLog.println(" ChatFedAmb is defined ");
      
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      if( joinFederationExecution(fedAmb) && getRtiIds() && publishSubscribe() )
      {
        
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeConstrained( );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        tickRTI(2);

        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );

        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
           isConnected = true;

        } catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

      }// end of if 

      if(isConnected) {
         mail.setEnabled(true);
         disconnect.setEnabled(true);
         connect.setEnabled(false);
      }// end of if

   }// end of doRealyConnect()

   /**
   * Connects for publishing.
   */
   void doConnect()
   {
          if( isConnected ) 
          giveError(" You are *already* connected! ");
     else if( myChatterName==null ) 
          giveError(" You did not specified your name connected! ");
     else doRealyConnect();

   }// end of doExit()

   /**
   * Disconnects from the Federation Execution.
   */
   void doDisconnect()
   {
     if( !isConnected ) giveError(" You are *already* disconnected! ");
     else { leaveFederationExecution(); isConnected=false; }
     mail.setEnabled(false);
     disconnect.setEnabled(false);
     connect.setEnabled(true);

   }// end of doDisconnect()

   /**
   */
   void doMail()
   {
     if( !isConnected ) giveError(" You are disconnected! "); 
     else
      {
        try
        { 
           RTIcap.ParameterHandleValuePair vals[] = new RTIcap.ParameterHandleValuePair[1];
           vals[0] = new RTIcap.ParameterHandleValuePair((short)chatterMsgTypeId,(myChatterName+" : "+sendMessage.getText()).getBytes());
           rtiAmb.sendInteraction(chatterTypeId,vals,"");
           addMessage(myChatterName+" : "+sendMessage.getText(), Color.red);
           sendMessage.setText("");

        } catch( RTIcap.InteractionClassNotDefined aa ) {}
          catch( RTIcap.InteractionClassNotPublished aa ) {}
          catch( RTIcap.InteractionParameterNotDefined aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}
         try { rtiAmb.tick( ); } 
         catch( RTIcap.RTIinternalError aa ) {}


      }

   }// end of doMail()

   /**
   */
   void doGetName()
   {
     GetName dialog = new GetName(this,myChatterName);

     dialog.pack();
     dialog.setLocationRelativeTo(this);
     dialog.show();
     myChatterName = dialog.getName();
     if( myChatterName!=null ) {
       if( myChatterName.trim().length()>0) {
         myChatterName=dialog.getName().trim();
         connect.setEnabled(true);
       } else myChatterName=null;
     }// end of if

   }// end of doGetName()

   JButton defineJButton(String bLabel, String iFile, 
                         String tip, int Mnemonic, boolean enabled) {
       ImageIcon theImage = null;
       try { theImage=new ImageIcon(new URL(getCodeBase()+iFile)); }
       catch(java.net.MalformedURLException mue) {}

       JButton ret    = new JButton(bLabel,theImage);
       ret.setToolTipText(tip);
       ret.setEnabled(enabled);
       ret.setMnemonic(Mnemonic);
       return ret;
   }

   /**
   * Displays the error message in the warning window.
   * @param mess Error message.
   */
   void giveError(String mess)
   {
     JOptionPane.showMessageDialog( this, "Sorry!"+"\n"+mess,"",
                                    JOptionPane.ERROR_MESSAGE);

   }// end of giveError()

   /**
   * @return 
   */
   public short getChatterRTITypeId() { return (short) chatterTypeId; }

   /**
   * @return 
   */
   public short getChatterRTIMsgTypeId() { return (short) chatterMsgTypeId; }

   /**
   * @param receivedMsg
   */
   public void  addMessage(byte[] receivedMsg )
   {
      String a = new String(receivedMsg);
      rcvMessages.append((a+"\n"));

   }// end of receivedMsg()

   /**
   * @param receivedMsg
   * @param txtColor
   */
   public void  addMessage(byte[] receivedMsg, Color txtColor )
   {
      String a = new String(receivedMsg);
      addMessage(a,txtColor);

   }// end of receivedMsg()

   /**
   * @param receivedMsg
   * @param txtColor
   */
   public void  addMessage(String receivedMsg, Color txtColor )
   {
      Color cColor = rcvMessages.getForeground();
      rcvMessages.setForeground(txtColor);
      rcvMessages.append((receivedMsg+"\n"));
      rcvMessages.setForeground(cColor);

   }// end of receivedMsg()

}// end of ChatGUI()

